Subject: Re: [RFC PATCH net-next 03/19] ipv6: Clear nexthop flags upon netdev up

From: Ido Schimmel <[email-masked]>
Date: Wed, 3 Jan 2018 22:53:21 +0200

On Wed, Jan 03, 2018 at 11:47:16AM -0700, David Ahern wrote:
> On 1/3/18 10:40 AM, Ido Schimmel wrote:
> > David, can we please get back to the issue at hand? What's the problem
> > with the location of the call to rt6_sync_up()?
> 
> My original comment was asking why do it on NETDEV_CHANGE when it should
> only be needed on NETDEV_UP.

I can condition the call to rt6_sync_up() on the event being NETDEV_UP,
but the location needs to stay the same. Before that the interface still
doesn't have an IP address.

Reason for this requirement is that rt6_sync_up() is going to generate
FIB_EVENT_NH_ADD events that instruct switch drivers to populate their
adjacency tables with the notified nexthop. For this to happen, the
nexthop device needs to have L3 configuration (e.g., RIF in mlxsw) which
is dependent on the presence of an IP address.